dev-libs/boost-static: actually enable PIC, fix the description
[nodoc-overlay.git] / dev-libs / boost-static / boost-static-1.91.0-r1.ebuild
1 # Copyright 1999-2026 Gentoo Authors
2 # Distributed under the terms of the GNU General Public License v2
3
4 EAPI=8
5
6 # Keep an eye on releases: https://www.boost.org/releases/
7
8 PYTHON_COMPAT=( python3_{11..14} )
9
10 inherit dot-a edo flag-o-matic multiprocessing python-r1 toolchain-funcs multilib-minimal
11
12 MY_PV="$(ver_rs 1- _)"
13
14 DESCRIPTION="Static Boost Libraries for C++"
15 HOMEPAGE="https://www.boost.org/"
16 SRC_URI="https://archives.boost.io/release/${PV}/source/boost_${MY_PV}.tar.bz2"
17 S="${WORKDIR}/${PN%-*}_${MY_PV}"
18
19 LICENSE="Boost-1.0"
20 SLOT="0/${PV}"
21 #KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~arm64-macos ~x64-macos ~x64-solaris"
22 IUSE="bzip2 +context debug doc icu lzma +nls mpi numpy python +stacktrace test test-full tools zlib zstd"
23 REQUIRED_USE="
24 python? ( ${PYTHON_REQUIRED_USE} )
25 test-full? ( test )
26 "
27 RESTRICT="!test? ( test )"
28
29 RDEPEND="
30 dev-libs/boost[static-libs]
31 context? ( dev-libs/boost[context] )
32 debug? ( dev-libs/boost[debug] )
33 doc? ( dev-libs/boost[doc] )
34 nls? ( dev-libs/boost[nls] )
35 stacktrace? ( dev-libs/boost[stacktrace] )
36 test? ( dev-libs/boost[test] )
37 test-full? ( dev-libs/boost[test-full] )
38 tools? ( dev-libs/boost[tools] )
39 bzip2? (
40 dev-libs/boost[bzip2]
41 app-arch/bzip2:=[${MULTILIB_USEDEP}]
42 )
43 icu? (
44 dev-libs/boost[icu]
45 dev-libs/icu:=[${MULTILIB_USEDEP}]
46 )
47 !icu? ( virtual/libiconv[${MULTILIB_USEDEP}] )
48 lzma? (
49 dev-libs/boost[lzma]
50 app-arch/xz-utils:=[${MULTILIB_USEDEP}]
51 )
52 mpi? (
53 dev-libs/boost[mpi]
54 virtual/mpi[${MULTILIB_USEDEP},threads]
55 )
56 python? (
57 dev-libs/boost[python]
58 ${PYTHON_DEPS}
59 numpy? ( dev-python/numpy:=[${PYTHON_USEDEP}] )
60 )
61 zlib? (
62 dev-libs/boost[zlib]
63 virtual/zlib:=[${MULTILIB_USEDEP}]
64 )
65 zstd? (
66 dev-libs/boost[zstd]
67 app-arch/zstd:=[${MULTILIB_USEDEP}]
68 )"
69 DEPEND="${RDEPEND}"
70 BDEPEND=">=dev-build/b2-5.1.0"
71
72 PATCHES=(
73 "${FILESDIR}"/${PN}-1.88.0-disable_icu_rpath.patch
74 "${FILESDIR}"/${PN}-1.88.0-build-auto_index-tool.patch
75 "${FILESDIR}"/${PN}-1.88.0-beast-network-sandbox.patch
76 "${FILESDIR}"/${PN}-1.88.0-bind-no-Werror.patch
77 "${FILESDIR}"/${PN}-1.88.0-system-crashing-test.patch
78 "${FILESDIR}"/${PN}-1.88.0-yap-cstdint.patch
79 # https://github.com/boostorg/dll/issues/108
80 "${FILESDIR}"/${PN}-1.89.0-dll-no-lto.patch
81 "${FILESDIR}"/${PN}-1.89.0-graph-remove-system-dependency.patch
82 "${FILESDIR}"/${PN}-1.89.0-predef-include-path.patch
83 "${FILESDIR}"/${PN}-1.89.0-python-exclude-broken-tests.patch
84 "${FILESDIR}"/${PN}-1.89.0-unordered-no-tbb.patch
85 "${FILESDIR}"/${PN}-1.90.0-cobalt.patch
86 "${FILESDIR}"/${PN}-1.90.0-msm-std.patch
87 "${FILESDIR}"/${PN}-1.90.0-unsigned-char-EOF.patch
88 "${FILESDIR}"/${PN}-1.91.0-spirit-test.patch
89 "${FILESDIR}"/${PN}-1.91.0-uninitialised-buffer.patch
90 "${FILESDIR}"/${PN}-1.91.0-wave-test-cfg.patch
91 )
92
93 create_user-config.jam() {
94 local user_config_jam="${BUILD_DIR}"/user-config.jam
95 if [[ -s ${user_config_jam} ]]; then
96 einfo "${user_config_jam} already exists, skipping configuration"
97 return
98 else
99 einfo "Creating configuration in ${user_config_jam}"
100 fi
101
102 local compiler compiler_version compiler_executable="$(tc-getCXX)"
103 compiler="gcc"
104 compiler_version="$(gcc-version)"
105
106 if use mpi; then
107 local mpi_configuration="using mpi ;"
108 fi
109
110 cat > "${user_config_jam}" <<- __EOF__ || die
111 using ${compiler} : ${compiler_version} : ${compiler_executable} : <cflags>"${CPPFLAGS} ${CFLAGS}" <cxxflags>"${CPPFLAGS} ${CXXFLAGS}" <linkflags>"${LDFLAGS}" <archiver>"$(tc-getAR)" <ranlib>"$(tc-getRANLIB)" ;
112 ${mpi_configuration}
113 __EOF__
114
115 if multilib_native_use python; then
116 append_to_user_config() {
117 local py_config
118 if tc-is-cross-compiler; then
119 py_config="using python : ${EPYTHON#python} : : ${ESYSROOT}/usr/include/${EPYTHON} : ${ESYSROOT}/usr/$(get_libdir) ;"
120 else
121 py_config="using python : ${EPYTHON#python} : ${PYTHON} : $(python_get_includedir) ;"
122 fi
123 echo "${py_config}" >> "${user_config_jam}" || die
124 }
125 python_foreach_impl append_to_user_config
126 fi
127
128 if multilib_native_use python && use numpy; then
129 einfo "Enabling support for NumPy extensions in Boost.Python"
130 else
131 einfo "Disabling support for NumPy extensions in Boost.Python"
132
133 # Boost.Build does not allow for disabling of numpy
134 # extensions, thereby leading to automagic numpy
135 # https://github.com/boostorg/python/issues/111#issuecomment-280447482
136 sed \
137 -e 's/\[ unless \[ python\.numpy \] : <build>no \]/<build>no/g' \
138 -i "${BUILD_DIR}"/libs/python/build/Jamfile || die
139 fi
140 }
141
142 pkg_setup() {
143 # Bail out on unsupported build configuration, bug #456792
144 if [[ -f "${EROOT}"/etc/site-config.jam ]]; then
145 if ! grep -q 'gentoo\(debug\|release\)' "${EROOT}"/etc/site-config.jam; then
146 eerror "You are using custom ${EROOT}/etc/site-config.jam without defined gentoorelease/gentoodebug targets."
147 eerror "Boost can not be built in such configuration."
148 eerror "Please, either remove this file or add targets from ${EROOT}/usr/share/boost-build/site-config.jam to it."
149 die "Unsupported target in ${EROOT}/etc/site-config.jam"
150 fi
151 fi
152 }
153
154 src_prepare() {
155 default
156 multilib_copy_sources
157 }
158
159 ejam() {
160 create_user-config.jam
161
162 local b2_opts=( "--user-config=${BUILD_DIR}/user-config.jam" )
163 if multilib_native_use python; then
164 append_to_b2_opts() {
165 b2_opts+=( python="${EPYTHON#python}" )
166 }
167 python_foreach_impl append_to_b2_opts
168 else
169 b2_opts+=( --without-python )
170 fi
171 b2_opts+=( "$@" )
172
173 echo b2 "${b2_opts[@]}" >&2
174 b2 "${b2_opts[@]}"
175 }
176
177 src_configure() {
178 # -Werror=odr
179 # https://bugs.gentoo.org/943975
180 # https://github.com/boostorg/quickbook/issues/27
181 # https://github.com/boostorg/spirit/issues/800
182 #
183 # Tests also fail:
184 # https://bugs.gentoo.org/956660
185 # https://github.com/boostorg/smart_ptr/issues/121
186 # https://github.com/boostorg/thread/issues/415
187 filter-lto
188
189 lto-guarantee-fat
190
191 # Workaround for too many parallel processes requested, bug #506064
192 [[ "$(makeopts_jobs)" -gt 64 ]] && MAKEOPTS="${MAKEOPTS} -j64"
193
194 # We don't want to end up with -L/usr/lib on our linker lines
195 # which then gives us lots of
196 # skipping incompatible /usr/lib/libc.a when searching for -lc
197 # warnings
198 [[ -n ${ESYSROOT} ]] && local icuarg="-sICU_PATH=${ESYSROOT}/usr"
199
200 OPTIONS=(
201 $(usex debug gentoodebug gentoorelease)
202 "-j$(makeopts_jobs)"
203 -q
204 -d+2
205 pch=off
206 $(usex icu "${icuarg}" '--disable-icu boost.locale.icu=off')
207 $(usev !mpi --without-mpi)
208 $(usev !nls --without-locale)
209 $(usev !context '--without-context --without-coroutine --without-fiber')
210 $(usev !stacktrace --without-stacktrace)
211 --boost-build="${BROOT}"/usr/share/b2/src
212 --layout=system
213 # building with threading=single is currently not possible
214 # https://svn.boost.org/trac/boost/ticket/7105
215 threading=multi
216 link=static
217 # this seems to be the only way to disable compression algorithms
218 # https://www.boost.org/doc/libs/1_70_0/libs/iostreams/doc/installation.html#boost-build
219 -sNO_BZIP2=$(usex bzip2 0 1)
220 -sNO_LZMA=$(usex lzma 0 1)
221 -sNO_ZLIB=$(usex zlib 0 1)
222 -sNO_ZSTD=$(usex zstd 0 1)
223 boost.stacktrace.from_exception=off
224 )
225
226 if [[ ${CHOST} == *-darwin* ]]; then
227 # We need to add the prefix, and in two cases this exceeds, so prepare
228 # for the largest possible space allocation.
229 append-ldflags -Wl,-headerpad_max_install_names
230 fi
231
232 # Use C++17 globally as of 1.80
233 append-cflags -fPIC
234 append-cxxflags -std=c++17 -fPIC
235
236 if [[ ${CHOST} != *-darwin* ]]; then
237 # On modern macOS, file I/O is already 64-bit by default,
238 # there's no support for special options like O_LARGEFILE.
239 # Thus, LFS must be disabled.
240 #
241 # On other systems, we need to enable LFS explicitly for 64-bit
242 # offsets on 32-bit hosts (#894564)
243 append-lfs-flags
244 fi
245 }
246
247 multilib_src_compile() {
248 ejam \
249 --prefix="${EPREFIX}"/usr \
250 "${OPTIONS[@]}" || die
251 }
252
253 multilib_src_test() {
254 ##
255 ## Test exclusions
256 ##
257
258 # The following libraries do not compile or fail their tests:
259 local libs_excluded=(
260 # it seems tests are no longer built
261 "callable_traits"
262 # test output comparison failure
263 "config"
264 # undefined reference to `boost::math::concepts::real_concept boost::math::bernoulli_b2n<boost::math::concepts::real_concept>(int)
265 "math"
266 # In function 'PyObject* boost::parameter::python::aux::unspecified_type()':
267 # /usr/include/python3.13/object.h:339:30: error: lvalue required as left operand of assignment
268 # #define Py_TYPE(ob) Py_TYPE(_PyObject_CAST(ob))
269 # ~~~~~~~^~~~~~~~~~~~~~~~~~~~
270 "parameter_python"
271 # scope/lambda_tests22.cpp(27): test 'x == 1' failed in function 'int main()'
272 "phoenix"
273 # vec_access.hpp:95:223: error: static assertion failed: Boost QVM static assertion failure
274 "qvm"
275 # In function 'void boost::redis::detail::update_sentinel_list(std::vector<boost::redis::address>&,
276 # std::size_t, boost::span<const boost::redis::address>, boost::span<const boost::redis::address>)':
277 # boost/redis/impl/sentinel_utils.hpp:269:20: error: no matching function for call to
278 # 'find(std::vector<boost::redis::address>::iterator, std::vector<boost::redis::address>::iterator,
279 # const boost::redis::address&)'
280 "redis"
281 # Processing file ../boost_1_89_0/libs/regex/example/../include/boost/regex/v5/regex_iterator.hpp
282 # terminate called after throwing an instance of 'std::length_error'
283 # what(): basic_string::_M_create
284 # https://github.com/boostorg/regex/issues/274
285 "regex"
286 # in function `boost::archive::tmpnam(char*)': test_array.cpp:(.text+0x108):
287 # undefined reference to `boost::filesystem::detail::unique_path(...)'
288 "serialization"
289 # TuTestMain.cpp(22) fatal error: in "test_main_caller( argc_ argv )":
290 # std::runtime_error: Event was not consumed!
291 "statechart"
292 )
293
294 if ! use mpi; then
295 # graph_parallel tries to use MPI even with use=-mpi
296 local no_mpi=( "mpi" "graph_parallel" )
297 einfo "Disabling tests due to USE=-mpi: ${no_mpi[@]}"
298 libs_excluded+=( ${no_mpi[@]} )
299 fi
300
301 if ! use test-full; then
302 # passes its tests but takes a very long time to build
303 local no_full=( "geometry" "multiprecision" )
304 einfo "Disabling expensive tests due to USE=-test-full: ${no_full[@]}"
305 libs_excluded+=( ${no_full[@]} )
306 fi
307
308 einfo "Skipping the following tests: ${libs_excluded[@]}"
309
310 ##
311 ## Find and run tests
312 ##
313
314 # Prepare to find libraries but without exclusions
315 local excluded findlibs="find ${BUILD_DIR}/libs -maxdepth 1 -mindepth 1 -type d "
316 for excluded in ${libs_excluded[@]}; do
317 findlibs+="-not -name ${excluded} "
318 done
319
320 # Must come as last argument
321 findlibs+="-print0"
322
323 # Collect libraries to test, with full path.
324 # The list is then sorted to provide predictable execution order,
325 # which would otherwise depend on the file system.
326 local libs
327 readarray -td '' libs < <(${findlibs})
328 readarray -td '' libs < <(printf '%s\0' "${libs[@]}" | sort -z)
329
330 # Build the list of test names we are about to run
331 local lib_names
332 for lib in ${libs[@]}; do
333 lib_names+=("${lib##*/}")
334 done
335
336 # Create custom options for tests based on the build settings
337 TEST_OPTIONS=("${OPTIONS[@]}")
338
339 # Dial down log output - the full b2 command used to compile & run
340 # a test suite will be printed by ejam and can be used to build
341 # and run the tests in a test suite's directory.
342 TEST_OPTIONS=("${TEST_OPTIONS[@]/-d+2/-d0}")
343
344 # Finally build & run all test suites
345 einfo "Running the following tests: ${lib_names[*]}"
346
347 local failed_tests=()
348 for lib in "${libs[@]}"; do
349 # Skip libraries without test directory
350 [[ ! -d "${lib}/test" ]] && continue
351
352 # Move into library test dir & run all tests
353 pushd "${lib}/test" >/dev/null || die
354 nonfatal edob -m "Running tests in: $(pwd)" ejam --prefix="${EPREFIX}"/usr "${TEST_OPTIONS[@]}" || failed_tests+=( "${lib}" )
355 popd >/dev/null || die
356 done
357
358 if (( ${#failed_tests[@]} )); then
359 eerror "Failed tests. Printing summary."
360 local failed_test
361 for failed_test in "${failed_tests[@]}" ; do
362 eerror "Failed test: ${failed_test}"
363 done
364 die "Tests failed."
365 fi
366 }
367
368 multilib_src_install() {
369 ejam \
370 --prefix="${ED}"/usr \
371 --includedir="${ED}"/usr/include \
372 --libdir="${ED}"/usr/$(get_libdir) \
373 "${OPTIONS[@]}" install || die "Installation of Boost libraries failed"
374
375 # boost's build system truely sucks for not having a destdir. Because for
376 # this reason we are forced to build with a prefix that includes the
377 # DESTROOT, dynamic libraries on Darwin end messed up, referencing the
378 # DESTROOT instread of the actual EPREFIX. There is no way out of here
379 # but to do it the dirty way of manually setting the right install_names.
380 if [[ ${CHOST} == *-darwin* ]]; then
381 einfo "Working around completely broken build-system(tm)"
382 local d
383 for d in "${ED}"/usr/lib/*.dylib; do
384 if [[ -f ${d} ]]; then
385 # fix the "soname"
386 ebegin " correcting install_name of ${d#${ED}}"
387 install_name_tool -id "/${d#${D}}" "${d}"
388 eend $?
389 # fix references to other libs
390 # these paths look like this:
391 # bin.v2/libs/thread/build/gcc-12.1/gentoorelease/pch-off/
392 # threadapi-pthread/threading-multi/visibility-hidden/
393 # libboost_thread.dylib
394 refs=$(otool -XL "${d}" | \
395 sed -e '1d' -e 's/^\t//' | \
396 grep "libboost_" | \
397 cut -f1 -d' ')
398 local r
399 for r in ${refs}; do
400 # strip path prefix from references, so we obtain
401 # something like libboost_thread.dylib.
402 local r_basename=${r##*/}
403
404 ebegin " correcting reference to ${r_basename}"
405 install_name_tool -change \
406 "${r}" \
407 "${EPREFIX}/usr/lib/${r_basename}" \
408 "${d}"
409 eend $?
410 done
411 fi
412 done
413 fi
414 }
415
416 multilib_src_install_all() {
417 rm -r "${ED}"/usr/include/boost || die
418 find "${ED}"/usr/$(get_libdir)/cmake -type f ! -name "*static*" -delete || die
419
420 local dlib
421 for dlib in /usr/lib64/libboost_regex.a /usr/lib64/libboost_exception.a /usr/lib64/libboost_test_exec_monitor.a; do
422 rm "${ED}${dlib}" || die
423 done
424
425
426 if use python; then
427 if use mpi; then
428 move_mpi_py_into_sitedir() {
429 python_moduleinto boost
430
431 python_domodule "${ED}"/usr/$(get_libdir)/boost-${EPYTHON}/mpi.so
432 rm -r "${ED}"/usr/$(get_libdir)/boost-${EPYTHON} || die
433
434 python_optimize
435 }
436 python_foreach_impl move_mpi_py_into_sitedir
437 fi
438 fi
439
440 strip-lto-bytecode
441 }
442
443 pkg_preinst() {
444 # Yay for having symlinks that are nigh-impossible to remove without
445 # resorting to dirty hacks like these. Removes lingering symlinks
446 # from the slotted versions.
447 local symlink
448 for symlink in "${EROOT}"/usr/share/boostbook; do
449 if [[ -L ${symlink} ]]; then
450 rm -f "${symlink}" || die
451 fi
452 done
453 }
454
455 pkg_postinst() {
456 elog "Boost.Regex is *extremely* ABI sensitive. If you get errors such as"
457 elog
458 elog " undefined reference to \`boost::re_detail_$(ver_cut 1)0$(ver_cut 2)00::cpp_regex_traits_implementation"
459 elog " <char>::transform_primary[abi:cxx11](char const*, char const*) const'"
460 elog
461 elog "Then you need to recompile Boost and all its reverse dependencies"
462 elog "using the same toolchain. In general, *every* change of the C++ toolchain"
463 elog "requires a complete rebuild of the Boost-dependent ecosystem."
464 elog
465 elog "See for instance https://bugs.gentoo.org/638138"
466 }